package com.steerinfo.meterwork.meterworkrailwayreceived.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworkrailwayreceived.mapper.MeterWorkRailwayReceivedMapper;
import com.steerinfo.meterwork.meterworkrailwayreceived.model.MeterWorkRailwayReceived;
import com.steerinfo.meterwork.meterworkrailwayreceived.service.IMeterWorkRailwayReceivedService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterWorkRailwayReceived RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-03-22 09:00
 * 类描述
 * 修订历史：
 * 日期：2022-03-22
 * 作者：generator
 * 参考：
 * 描述：MeterWorkRailwayReceived RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterworkrailwayreceiveds")
public class MeterWorkRailwayReceivedController extends BaseRESTfulController {

    @Autowired
    IMeterWorkRailwayReceivedService meterWorkRailwayReceivedService;

    @Resource
    MeterWorkRailwayReceivedMapper meterWorkRailwayReceivedMapper;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkrailwayreceived:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkRailwayReceived> list = meterWorkRailwayReceivedService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkrailwayreceived:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkRailwayReceived> list = meterWorkRailwayReceivedService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value = "获取动态轨道衡从表数据-获取列表", notes = "分页模糊查询")
    @PostMapping(value = "/likeByDesc")
    public RESTfulResult likeDesc(@RequestBody HashMap parmas) {
        try {
            PageList<MeterWorkRailwayReceived> list = meterWorkRailwayReceivedService.likeByDesc(parmas, Integer.parseInt(parmas.get("pageNum").toString()), Integer.parseInt(parmas.get("pageSize").toString()));
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkrailwayreceived:view")
    @PostMapping(value = "/listLikePost/")
    public RESTfulResult listLikePost(@RequestBody HashMap parmas){
        Integer pageNum = parmas.get("pageNum") == null ? 1 : Integer.parseInt(parmas.get("pageNum").toString());
        Integer pageSize =parmas.get("pageSize") == null ? 20 : Integer.parseInt(parmas.get("pageSize").toString());
        PageList<MeterWorkRailwayReceived> list = meterWorkRailwayReceivedService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="不分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkrailwayreceived:view")
    @PostMapping(value = "/noPage")
    public RESTfulResult noPage(@RequestBody HashMap parmas){
        List<MeterWorkRailwayReceived> list = meterWorkRailwayReceivedService.noPage(parmas);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterWorkRailwayReceived对象创建")
    @ApiImplicitParam(name = "meterWorkRailwayReceived", value = "详细实体meterWorkRailwayReceived", required = true, dataType = "MeterWorkRailwayReceived")
    //@RequiresPermissions("meterworkrailwayreceived:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MeterWorkRailwayReceived model){
        RESTfulResult rm = failed();
        try {
            RESTfulResult res = meterWorkRailwayReceivedService.checkandadd(model);
            return res;
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkrailwayreceived:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterWorkRailwayReceived meterWorkRailwayReceived = meterWorkRailwayReceivedService.getById(id);
        return success(meterWorkRailwayReceived);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterWorkRailwayReceived信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterWorkRailwayReceived", value = "详细实体meterWorkRailwayReceived", required = true, dataType = "MeterWorkRailwayReceived")
    })
    //@RequiresPermissions("meterworkrailwayreceived:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterWorkRailwayReceived model){
        model.setId(id);
        MeterWorkRailwayReceived meterWorkRailwayReceived = meterWorkRailwayReceivedService.modify(model);
        return success(meterWorkRailwayReceived);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkrailwayreceived:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterWorkRailwayReceivedService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterWorkRailwayReceived信息来更新详细信息")
    @PostMapping(value = "/updateReceived", produces  = "application/json;charset=UTF-8")
    public RESTfulResult updateReceived(@RequestBody MeterWorkRailwayReceived model){
        RESTfulResult rm = new RESTfulResult();
        try {
            int num = meterWorkRailwayReceivedMapper.updateByPrimaryKeySelective(model);
            rm.setCode("200");
            rm.setData(num);
            rm.setMessage("成功");
            return rm;
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterWorkRailwayReceived信息来更新详细信息")
    @PostMapping(value = "/updateList", produces  = "application/json;charset=UTF-8")
    public RESTfulResult updateList(@RequestBody List<MeterWorkRailwayReceived> models){
        RESTfulResult rm = new RESTfulResult();
        try {
            rm = meterWorkRailwayReceivedService.updateList(models);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterWorkRailwayReceived信息来更新详细信息")
    @PostMapping(value = "/updateListStart", produces  = "application/json;charset=UTF-8")
    public RESTfulResult updateListStart(@RequestBody List<MeterWorkRailwayReceived> models){
        RESTfulResult rm = new RESTfulResult();
        try {
            rm = meterWorkRailwayReceivedService.updateListStart(models);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterWorkRailwayReceived信息来更新详细信息")
    @PostMapping(value = "/addList", produces  = "application/json;charset=UTF-8")
    public RESTfulResult addList(@RequestBody List<MeterWorkRailwayReceived> models){
        RESTfulResult rm = new RESTfulResult();
        try {
            rm = meterWorkRailwayReceivedService.addList(models);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterWorkRailwayReceived信息来更新详细信息")
    @PostMapping(value = "/RemovePre", produces  = "application/json;charset=UTF-8")
    public RESTfulResult RemovePre(@RequestBody List<MeterWorkRailwayReceived> models){
        RESTfulResult rm = new RESTfulResult();
        try {
            rm = meterWorkRailwayReceivedService.RemovePre(models);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterWorkRailwayReceived信息来更新详细信息")
    @PostMapping(value = "/matchPre", produces  = "application/json;charset=UTF-8")
    public RESTfulResult matchPre(@RequestBody MeterWorkRailwayReceived model){
        RESTfulResult rm = new RESTfulResult();
        try {
            rm = meterWorkRailwayReceivedService.matchPre(model);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value="批量更新信息", notes="根据url的id来指定更新对象，并根据传过来的meterWorkRailwayReceived信息来更新详细信息")
    @PostMapping(value = "/batchMatchPre", produces  = "application/json;charset=UTF-8")
    public RESTfulResult matchPre(@RequestBody List<MeterWorkRailwayReceived> models){
        RESTfulResult rm = new RESTfulResult();
        try {
            rm = meterWorkRailwayReceivedService.batchMatchPre(models);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterWorkRailwayReceived信息来更新详细信息")
    @PostMapping(value = "/removeList", produces  = "application/json;charset=UTF-8")
    public RESTfulResult removeList(@RequestBody List<MeterWorkRailwayReceived> models){
        RESTfulResult rm = new RESTfulResult();
        try {
            rm = meterWorkRailwayReceivedService.removeList(models);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }
}
